<template>
  <div>
    <div class="select-add-card__content">
      <div class="select-add-card__content-column">
        <!--Раздел оплаты-->

        <div class="select-add-card__content-column select-add-card__content-left">
          <div class="flex-column select-add-card__radio-buttons" v-if="showCardSelector">
            <div class="radio-button" v-for="card in array_cards">
              <input :key="card.id"
                     :value="card"
                     :id="`card-${card.id}`"
                     v-model="selectedCard"
                     class="radio-button__input"
                     type="radio"
                     name="radio"/>
              <label :for="`card-${card.id}`" class="radio-button__label">
                <img class="radio-button__label-icon" :src="card.iconSmall"/>
                {{card.description}}
              </label>
            </div>
            <div class="radio-button">
              <input id="newCard" class="radio-button__input"
                     type="radio"
                     name="radio"
                     v-model="selectedCard"/>
              <label for="newCard" class="radio-button__label">
                <SVGIcon class="radio-button__label-icon" xlink="add-card-45" viewBox="0 0 45 45"/>
                Новая карта
              </label>
            </div>
          </div>

          <!--Блок для вывода информации по карте-->

          <transition name="fade" v-if="!selectedCard">
            <div class="select-add-card__card" @keyup.enter="payOtherCard">
              <div class="select-block-for-add-card">
                <div class="row" style="position: relative">
                  <label for="cardNumber">Номер карты</label>
                  <input id="cardNumber"
                         name="номер карты"
                         class="acceptance__content-input"
                         v-mask="masks"
                         data-vv-delay="200"
                         v-model="numberCard"
                         placeholder="0000-0000-0000-0000"
                         type="tel"
                         autocomplete="off"

                         v-validate="'required|cardNumberValidate'"
                         data-vv-validate-on="blur"
                         :class="{error: vErrors.has('номер карты')}"
                  />
                  <img v-show="cardImg" :src="cardImg" class="select-img-card">
                  <validate-message v-show="vErrors.has('номер карты')">
                    {{ vErrors.first('номер карты') }}
                  </validate-message>
                </div>
                <div class="row">
                  <div class="columns six">
                    <label for="cardDate" class="acceptance__content-select-title">Срок действия</label>
                    <input id="cardDate"
                           class="acceptance__content-input"
                           v-mask="'##/##'"
                           name="дата"
                           type="tel"
                           data-vv-delay="200"
                           data-vv-validate-on="blur"
                           v-model="formatter"
                           placeholder="ММ/ГГ"
                           autocomplete="off"

                           v-validate="'required|date_format:MM/DD'"
                           :class="{error: vErrors.has('дата')}"
                    />
                    <validate-message v-show="vErrors.has('дата')">
                      {{ vErrors.first('дата') ? 'Дата должна быть указана MM/ГГ' : '' }}
                      <!--{{ vErrors.first('дата') }}-->
                    </validate-message>
                  </div>
                  <div class="columns six">
                    <label for="cardDate" class="acceptance__content-select-title">CVC/CVV</label>
                    <input id="cvc"
                           name="cvc"
                           class="acceptance__content-input acceptance__content-input-cvc"
                           v-mask="'###'"
                           v-model="cvc"
                           maxlength="3"
                           placeholder="CVC/CVV"
                           data-vv-delay="200"
                           type="tel"
                           data-vv-validate-on="blur"
                           autocomplete="off"
                           v-validate="'required|cvv'"
                           :class="{error: vErrors.has('cvc')}"
                    />
                    <validate-message v-show="vErrors.has('cvc')">
                      {{ vErrors.first('cvc') }}
                    </validate-message>
                  </div>
                </div>
                <div class="row">
                  <label for="cardNameHolder">Имя держателя карты</label>
                  <input id="cardNameHolder"
                         type="text"
                         class="acceptance__content-input"
                         v-model="holder"
                         v-validate="'holderNameValidate'"
                         data-vv-delay="200"
                         :class="{error: vErrors.has('имя держателя карты')}"
                         name="имя держателя карты"
                         autocomplete="off"

                  />
                  <validate-message v-show="vErrors.has('имя держателя карты')">
                    {{ vErrors.first('имя держателя карты') }}
                  </validate-message>
                </div>
              </div>
            </div>
          </transition>
        </div>

        <!--Описание платежа-->

        <div class="select-add-card__content-column select-add-card__content-right">
          <div class="select-add-card__sum">
            <div class="select-add-card__sum-full flex-row space-between">
              <span class="select-add-card__title">Вносимый платеж</span>
              <span class="select-add-card__value">{{(isNaN(sum) ? 0 : sum)|currency}} ₽</span>
            </div>

            <div class="select-add-card__sum-full flex-row space-between" v-for="item in additional_service">
              <span class="select-add-card__title">{{item.title}}</span>
              <span class="select-add-card__value">{{Number(item.price)|currency}} ₽</span>
            </div>
            <div class="select-add-card__sum-full flex-row space-between bonus_balance" v-if="$pay.bonusPaySum">
              <span class="select-add-card__title bonus_balance">Бонусные рубли</span>
              <span class="select-add-card__value bonus_balance">-{{$pay.bonusPaySum|currency}} ₽</span>
            </div>
            <div class="select-add-card__sum-full flex-row space-between">
              <span class="select-add-card__title select-add-card__p">Сумма к оплате</span>
              <span class="select-add-card__value select-add-card__h2">{{(isNaN(totalAmount) ? 0: totalAmount)|currency}} ₽</span>
            </div>
          </div>
          <div class="select-add-card__transaction">
            <div class="flex-column">
              <span class="select-add-card__title">№ транзакции:</span>
              <span class="select-add-card__value">{{$pdl.id}}</span>
            </div>
          </div>
          <transition name="fade">

            <div class="select-add-card__buttons-wrapper" v-if="!cashbackErrorCode">

              <div class="select-add-card__button button red" @click="pay">Оплатить</div>

              <div class="select-add-card__button button white"
                   @click="$emit('cancelPay'); $store.commit('setServiceGuid', {data: []})">Отменить</div>
            </div>

            <!-- <div class="cashback-error" v-else>
              <div class="title">Ошибка при оплате с бонусного счета</div>
              При оплате с бонусного счета произошла ошибка. Вы можете оплатить всю сумму с помощью карты или отменить оплату.
              <div class="buttons">
                  <div class="message-button cardPay" @click="removeBonus">
                    Оплатить картой
                  </div>
                  <div class="message-button" @click="$emit('back')">
                    Отменить оплату
                  </div>
              </div>
            </div> -->
            <ui-alert v-if="cashbackErrorCode" :isSingleLine="false" type="warning" alertTitle="Ошибка при оплате с бонусного счета.">
              <div slot="alert-body">
                <div class="alertContent">
                  При оплате с бонусного счета произошла ошибка. Вы можете оплатить всю сумму с помощью карты или отменить оплату.
                </div>
                <div>
                  <ui-button @click="removeBonus" customClasses="primary">Оплатить картой</ui-button>
                  <ui-button @click="$emit('back')">Отменить оплату</ui-button>
                </div>
              </div>
            </ui-alert>
          </transition>
        </div>
      </div>
    </div>
    <div class="select-add-card__footer">
      <div class="select-add-card__footer-icons">
        <SVGIcon class="select-add-card__footer-icons-icon"
                 v-for="item in footerSecureIcons"
                 :key="item.xlink"
                 :xlink="item.xlink"
                 :viewBox="item.viewBox"/>
      </div>
      <div class="select-add-card__footer-secure">
        <SVGIcon class="select-add-card__footer-secure-icon"
                 xlink="lock"
                 viewBox="0 0 20 20"/>
        <p class="select-add-card__footer-secure-title">Безопасное соединение</p>
      </div>
    </div>

    <!--Форма для 3DS карт-->
    <modal name="tds-frame-modal"
           class="arcticmodal-container full-viewport"
           width="600"
           height="auto"
           :show="true"
           :adaptive=true
           :clickToClose="false"
           @opened="tdsModalReady"
           @before-open="$helpers.noscroll(true)"
           @before-close="$helpers.noscroll(false)">
      <div class="popup">
        <div class="popup__wrapper">
          <div class="popup__header popup__header-with-back">
            <div class="popup__back" @click="closeTdsModal">
              <SVGIcon xlink="next-arrow-20" viewBox="0 0 20 20" :rotate="180"/>
            </div>
            <h3 class="popup__header-title">Подтверждение оплаты</h3>
          </div>
          <div class="popup__content my-accounts-modal1">
            <div class="row" style="position: relative">
              <iframe ref="iframe"
                      width="100%"
                      :style="$interface.isMobile ? 'height: calc(100vh - 100px)' : 'height: calc(50vh - 100px)'"
                      :name="tdsFrameId"
                      id="pay-frame"
                      frameborder="0"
                      @load="tdsFrameOnLoad"
              ></iframe>

              <form :id="tdsFrameId" :action="formData.url" :target="tdsFrameId" ref="form" method="post" v-show="false">
                <input type="hidden" v-for="(v, name) in formData.postData" :name="name" :value="v">
              </form>
            </div>
          </div>
        </div>
      </div>
    </modal>

    <!-- Бонусные рубли списаны, но оплата не прошла-->

    <modal name="payWarning"
           class="arcticmodal-container full-viewport"
           width="600"
           height="auto"
           :show="true"
           :adaptive=true
           :clickToClose="false"
           @before-open="$helpers.noscroll(true)"
           @before-close="$helpers.noscroll(false)">
      <div class="popup">
        <div class="popup__wrapper">
          <div class="popup__header popup__header-with-back">
            <div class="popup__back" @click="$modal.hide('payWarning'); ">
              <SVGIcon xlink="next-arrow-20" viewBox="0 0 20 20" :rotate="180"/>
            </div>
            <h3 class="popup__header-title">Результат оплаты</h3>
          </div>
          <div class="popup__content my-accounts-modal1">
            <div class="row" style="position: relative">

              <div class="row pay-result-warning center">
                <div class="column">
                  <div>
                      <img src="/lk/static/img/content/warning.png" alt=""/>
                      <b class="header">Оплата с бонусного счета прошла успешно, но не удалось произвести оплату картой</b>
                      <p style="text-align: center">
                        Мы автоматически уменьшили сумму вашего платежа на списанную сумму с бонусного счета. Вы можете оплатить остаток вашей задолженности с помощью другой карты или другим способом оплаты
                      </p>
                      <button class="blue" style="margin-right: 0" @click="clearCardData">Оплатить другой картой</button>
                      <button @click="$emit('anyWayPay')">выбрать другой способ оплаты</button>
                  </div>
                </div>
              </div>

            </div>
          </div>
        </div>
      </div>
    </modal>



    <pay-result v-if="state" :state="state" @close-message="$events.$emit('myloan.reset')"></pay-result>


  </div>
</template>

<script>
    import debounce from 'lodash/debounce';

    import SVGIcon from "@/components/SVGIcon";
  import ValidateMessage from '@/components/Validators/ValidateMessage'
  import cardType from 'credit-card-type'
  import Card from '@/mixins/Card'
  import PayResult from '@/components/Modals/PayResult'


    const default_card_data = () => {
      return  {
        number: '',
        holder: '',
        year: '',
        month: '',
        cvc: '',
      }
    };

  export default {
    name: "SelectCardAddNew",
    components: {
        SVGIcon,
        PayResult,
    },
    mixins: [ValidateMessage, Card],
    data() {
      return {
          cashbackErrorCode: '',
          loading: false,
        // раздел для карт, которые токенизированы
        array_cards: [],
        selectedCard: '',
        // раздел для новой карты
        card: default_card_data(),
        showOriginalCvc: true,
        cvc_cvv: 'tel',
        masks: '####-####-####-####',
        numberCard: '',
        series: [],
        cardImg: '',
        formatter: '',
        // раздел для футера
        footerSecureIcons: [{
          xlink: 'verified-by-visa',
          viewBox: '0 0 65 40'
        }, {
          xlink: 'master-card-secure-code',
          viewBox: '0 0 85 40'
        }, {
          xlink: 'mir-accept',
          viewBox: '0 0 75 40'
        }, {
          xlink: 'pci-dss',
          viewBox: '0 0 80 40'
        }],
        // форма для 3DS карт
        formData: {},
          showTdsFrame: false,
          tdsFrameId: 'tdsFrameId',
          state: 0,
          tdsLoading: false
      }
    },
    props: {
      sum: {
        type: Number,
        default: 0
      },
      additional_service: {
        required: true,
        default: [],
        type: Array
      }
    },
    computed: {
        cvc: {
            get() {
                return this.showOriginalCvc ? this.card.cvc : this.formattedCvc;
            },
            set(value) {
                const { cvc } = this.card;

                this.card.cvc = this.showOriginalCvc
                    ? value
                    : cvc.length < value.length
                        ? cvc + value.substr(cvc.length, value.length - cvc.length)
                        : cvc.substr(0, value.length);
                this.showOriginalCvc = true;

                this.onCvcChange();
            }
        },
        formattedCvc() {
            return '•••'.substr(0, this.card.cvc.length);
        },
      totalAmount () {
        let cost = 0;
        this.additional_service.forEach(x => cost += parseFloat(x.price));
        return this.sum + cost - (this.$pay.bonusPaySum || 0)
      },
        showCardSelector () {
            return this.$accounts.find(a => a.has_token);
        }
    },
    watch: {
      'numberCard' (card) {
        let symbols = card.split('-');
        this.series = symbols;
        this.getMask(cardType(symbols[0]));
        let img = cardType(symbols[0]);
        this.cardImg = (card.length !== 0 && img.length !== 0) ? `/lk/static/img/my-accounts/${img[0].type}.png` : ''; // подставляем иконку типа карты (виза, мастер-кард и т.д)
        this.card.number = symbols.join('');
      },
      'card.cvc' () {
		  this.cvc_cvv = 'tel';
          setTimeout(() => this.cvc_cvv = 'password', 1000)
      }
    },
      created () {
          this.onCvcChange = debounce(this.onCvcChange, 500);

          this.$events.$on('debug.payment.tds.form', (form) => {
              this.formData = form;
              this.showTdsFrame = true;

              this.tdsModalReady();
          });

          this.tdsFrameId = 'f' + Math.random().toString(36).substring(7);
      },
    mounted () {
      this.array_cards = this.$accounts.filter((key) => key.has_token === true);
      this.selectedCard =  this.array_cards.find(key => key.main === 1) || this.array_cards[0];
    },
    beforeDestroy () {
      window.removeEventListener('message', this.postMessage);
    },
    methods: {
        onCvcChange() {
            this.showOriginalCvc = false;
        },
        removeBonus () {
            this.pay();
            this.$store.commit('PAYMENT_CLEAR_BONUS_SUM');
            this.cashbackErrorCode = '';
        },
      getMask(mask) {
        if (mask.length !== 0) {
          let largest = Math.max.apply(Math, mask[0].lengths);
          switch (largest) {
            case 19:
              this.masks = '####-####-####-#######';
              break;
            case 18:
              this.masks = '####-####-####-######';
              break;
            default:
              this.masks = '####-####-####-####';
              break;
          }
        } else {
          this.masks = '####-####-####-####'
        }
      },
      clearCardData () {
        Object.keys(this.card).forEach(key => this.card[key] = '');
        this.numberCard = '';
        this.formatter = '';
        this.$modal.hide('payWarning')
      },
      pay () {
        if (this.$pay.bonusPaySum) {
          this.payCashback()
        } else {
          this.selectedCard ? this.payYourCard() : this.payOtherCard();
        }
      },
        async payCashback () {
			this.AJAX_LOADING(true);

			await this.$backend.api.payment.pay.cashback({
				sum: String(this.$pay.bonusPaySum),
				paymentData: [{
					type: String(this.$pdl.type),
					number: String(this.$pdl.id)
				}]
			}).then(({data}) => {
                let res = data?.data?.result;
				this.selectedCard ? this.payYourCard(res) : this.payOtherCard(res);
			}).catch((e) => {
				this.cashbackErrorCode = this.$getErrorCode(e);
				this.AJAX_LOADING(false);
			}).finally(() => {
				this.$store.dispatch('PAYMENT_GET_BONUS_BALANCE');
				return Promise.resolve();
			});
        },
        async payYourCard(bonus = '') {
			this.$backend.log({
				action: 'pay',
                tokenize: 1,
                accountId: this.selectedCard.id,
                state: 1,
                timeStart: new Date().getTime(),
                meta: {
                    user_id: this.$user.id,
                    loan_id: this.$pdl?.id
                }
            }, false);

            this.AJAX_LOADING({
                caption: 'Идет оплата',
                waitingTitle: 'Обработка платежа',
                name: 'rootFixed',
                isShow: true
            });

            this.$helpers.noscroll(true);

            this.$backend.api.payment.pay.token({
                ...this.fields(),
                accountId: this.selectedCard.id
            })
                .then(({data}) => {
                    this.$backend.log({
                        action: 'pay',
                        tokenize: 1,
                        accountId: this.selectedCard.id,
                        state: 2,
                        timeStart: new Date().getTime(),
                        meta: {
                            user_id: this.$user.id,
                            loan_id: this.$pdl?.id
                        },
                        response: data?.data
                    }, false);
                    console.log('send success event with', data?.data);
                    this.$emit('success', data?.data);
                    this.$events.$emit('payment.card.token.success', data?.data);
                    this.$events.$emit('myloan.update.payment', data?.data);
                })
                .catch((err) => {
                    this.$backend.log({
                        action: 'pay',
                        tokenize: 1,
                        accountId: this.selectedCard.id,
                        state: 3,
                        timeStart: new Date().getTime(),
                        error: err,
                        meta: {
                            user_id: this.$user.id,
                            loan_id: this.$pdl?.id
                        }
                    }, false);
                    console.log('Ошибки по проведению оплаты: ', err);
                    // bonus ? this.$modal.show('payWarning') :
                    this.$toastr.error('Во время оплаты произошла непредвиденная ошибка.', 'Ошибка');
			    })
                .finally(() => {
                    this.AJAX_LOADING(false);
                    this.$helpers.noscroll(false);
                });
        },

        /**
         * Функция вызывается когда модальное окно с фреймом ТДС открылось.
         */
        tdsModalReady () {
              console.log('SelectCard::tdsModalReady.form', this.$refs.form);
              console.log('SelectCard::tdsModalReady.frame', document.querySelector(`#${this.tdsFrameId}`))
              document.querySelector(`#${this.tdsFrameId}`).submit();
              this.AJAX_LOADING(false);
              window.addEventListener('message', this.postMessage, {
                  passive: true
              });
        },

        /**
         * Срабатывает когда контент фрейм будет загружен (нужен чтобы убрать прелоадер)
         * @param e
         */
        tdsFrameOnLoad  (e) {
            console.log('SelectCard::tdsFrameLoad', e);
            this.tdsLoading = false;

        },

      async payOtherCard (bonus = '') {
        const valid = await this.$validator.validateAll();

        if (!valid) {
          this.$toastr.error('Заполните все поля', 'Ошибка');
          this.$helpers.focus();
          return;
        }

        this.loading = true;
        const card = {
          cvc: this.card.cvc,
          holder: this.card.holder,
          month: this.card.month,
          number: this.card.number,
          year: '20' + this.card.year
        };
        card.number = card.number.replace(/[^\d]/g, '');
        this.$payment.process = true;
        this.AJAX_LOADING({
          caption: 'Идет оплата',
          waitingTitle: 'Обработка платежа',
          name: "rootFixed",
          isShow: true
        });
        this.$helpers.noscroll(true);

          this.$backend.log({
              action: 'pay',
              tokenize: 0,
              state: 1,
              timeStart: new Date().getTime(),
              meta: {
                  user_id: this.$user.id,
                  loan_id: this.$pdl?.id
              }
          }, false);

        this.$backend.api.payment.pay.card({
          ...this.fields(),
          card
        }).then(({data}) => {
          if (data.data.type === 'tds') {
              this.showTdsFrame = true;
              this.formData = data.data;
              this.$modal.show('tds-frame-modal');
              // this.tdsLoading = true;
              this.AJAX_LOADING(false);

              this.$backend.log({
                  action: 'pay',
                  tokenize: 1,
                  state: 2,
                  tds: 1,
                  timeStart: new Date().getTime(),
                  meta: {
                      user_id: this.$user.id,
                      loan_id: this.$pdl?.id
                  },
                  response: data?.data
              }, false);
          } else {
            if (data.data.amount) {
              this.$emit('success');
              this.$store.commit('PAYMENT_TRUNCATE_ADDITIONAL_SERVICES');
                this.$events.$emit('myloan.update.payment', data?.data);
            }

              this.$backend.log({
                  action: 'pay',
                  tokenize: 1,
                  state: 2,
                  tds: false,
                  timeStart: new Date().getTime(),
                  meta: {
                      user_id: this.$user.id,
                      loan_id: this.$pdl?.id
                  },
                  response: data?.data
              }, false);
          }

        }).catch((e) => {
          console.warn('error', e);
          this.$payment.process = false;
          this.BUTTON_LOADING(false);

          if (Array.isArray(e.errors)) {
            switch (e.errors[0].code) {
              case 'paymentError':
                if (e.errors[0].message.startsWith('Card not supported')) {
                  this.$toastr.error('Нельзя произвести оплату данной картой. Проверьте номер или попробуйте другую.', 'Ошибка');
                  return;
                }
                this.$toastr.error('Ошибка платежного шлюза. Попробуйте повторить запрос через минуту.', 'Ошибка');
                break;
              case 'amountError':
                this.$toastr.error('Сумма должна быть более 10 рублей.', 'Ошибка');
                break;
              case 'cardYearIncorrect':
                this.$toastr.error('Срок действия карты указан не действительный.', 'Ошибка');
                break;
              case 'card.numberIsEmpty':
                this.$toastr.error('Недействительный номер карты.', 'Ошибка');
                break;
              case 'card.yearIsEmpty':
                this.$toastr.error('Срок действия карты (год) не заполнен.', 'Ошибка');
                break;
              case 'card.monthIsEmpty':
                this.$toastr.error('Срок действия карты (месяц) не заполнен.', 'Ошибка');
                break;
              case 'card.cvcIsEmpty':
                this.$toastr.error('Не задан код CVV/CVC.', 'Ошибка');
                break;
              default:
				  //bonus ? this.$modal.show('payWarning') :
                          this.$toastr.error('Во время оплаты произошла непредвиденная ошибка.', 'Ошибка');
                break;
            }
          } else {
            this.$toastr.error('Нельзя произвести оплату данной картой. Проверьте номер или попробуйте другую.', 'Ошибка');
          }
        }).finally(() => {
          this.AJAX_LOADING(false);
          this.$helpers.noscroll(false);
            this.loading = false;

        })
      },

      postMessage (msg) {
          console.log('SelectCard::postMessage', msg);
          if (msg?.data?.success) {
              this.$emit('success');
              this.state = 1;
              this.$modal.hide('tds-frame-modal');
              this.$modal.show('payResult');
              this.$events.$emit('myloan.update.payment', msg?.data);

              this.$backend.log({
                  action: 'pay',
                  state: 2,
                  timeStart: new Date().getTime(),
                  tds: 2,
                  meta: {
                      user_id: this.$user.id,
                      loan_id: this.$pdl?.id
                  },
                  msg: msg.data,
              }, false);


          } else if (msg?.data?.error) {
              this.$toastr.error('Платеж не был произведен', 'Ошибка');
              this.$emit('error');
              this.state = 2;
              this.$modal.hide('tds-frame-modal');
              this.$modal.show('payResult');

              this.$backend.log({
                  action: 'pay',
                  state: 2,
                  tds: 3,
                  timeStart: new Date().getTime(),
                  meta: {
                      user_id: this.$user.id,
                      loan_id: this.$pdl?.id
                  },
                  msg: msg.data,
              }, false);
          } else {
              this.$toastr.error('Ошибка на сервере. Повторите Ваш запрос', 'Ошибка');
          }
      },
      fields() {
        const data = {};
        data.sum = this.totalAmount;
        data.user_id = this.$user.id;
        data.paymentData = [];
        data.source = 1;
        if (this.$pay.paymentType === 'credit_rating') {
          this.$service.guid.data.forEach((guid) => {
            data.paymentData.push({
              type: 5,
              number: guid
            });
          })
        } else if (this.$pay.paymentType === 'installment_payment') {
          let schedule = this.$installment.currentPaymentBySchedule;
          schedule.sales.forEach((sale) => {
            if (sale.selected) {
              data.paymentData.push({
                type: 6,
                number: String(sale.id)
              })
            }
          });
        } else if(this.$pay.paymentType === 'POS') {
          this.$pay.paymentValues.ids.forEach((id) => {
            data.paymentData.push({
              type: 5,
              number: String(id)
            })
          })
        } else {
          this.$pay.paymentOrder.forEach((pay) => {
            data.paymentData.push({
              type: pay.type,
              number: String(pay.id)
            })
          });
          if (this.$pay.additionalServices.length) {
              this.$pay.additionalServices.forEach((number) => {
                data.paymentData.unshift({type: 5, number: String(number)});
            })
          }
        }
        return data;
      },
      closeTdsModal () {
        this.$modal.hide('tds-frame-modal');
        this.card = default_card_data();
      }
    }
  }
</script>

<style scoped lang="scss">
  @import "static/css/variables/media.scss";
  @import "static/css/variables/color.scss";

  .alertContent {
    padding: 0px 0px 15px 0px;
  }

  .cashback-error {
    border-radius: 5px;
    color: #323c47;
    line-height: 1.33;
    letter-spacing: 0.5px;
    font-size: 15px;
    padding: 15px 50px;
    background: rgba(255, 208, 18, 0.1) url('data:image/svg+xml;base64,PHN2ZyB4bWxucz0iaHR0cDovL3d3dy53My5vcmcvMjAwMC9zdmciIHhtbG5zOnhsaW5rPSJodHRwOi8vd3d3LnczLm9yZy8xOTk5L3hsaW5rIiB3aWR0aD0iMjAiIGhlaWdodD0iMjAiIHZpZXdCb3g9IjAgMCAyMCAyMCIgPgogICAgPGRlZnM+CiAgICAgICAgPHBhdGggaWQ9ImEiIGQ9Ik0xMS4xNTMgMi4wMDZsOC4zMzggMTQuNjYzYy4zNjQuNjQuMTQzIDEuNDU2LS40OTQgMS44MjItLjIuMTE1LS40MjguMTc2LS42NTkuMTc2SDEuNjYyYTEuMzMyIDEuMzMyIDAgMCAxLTEuMzI5LTEuMzM1YzAtLjIzMy4wNi0uNDYuMTc1LS42NjNMOC44NDcgMi4wMDZhMS4zMjUgMS4zMjUgMCAwIDEgMi4zMDYgMHpNMTAgMTZhMSAxIDAgMSAwIDAtMiAxIDEgMCAwIDAgMCAyem0tLjY2Ny05LjMzM3Y2aDEuMzM0di02SDkuMzMzeiIvPgogICAgPC9kZWZzPgogICAgPGcgZmlsbD0ibm9uZSIgZmlsbC1ydWxlPSJldmVub2RkIj4KICAgICAgICA8bWFzayBpZD0iYiIgZmlsbD0iI2ZmZiI+CiAgICAgICAgICAgIDx1c2UgeGxpbms6aHJlZj0iI2EiLz4KICAgICAgICA8L21hc2s+CiAgICAgICAgPGcgZmlsbD0iI2ZmZDAxMiIgZmlsbC1ydWxlPSJub256ZXJvIiBtYXNrPSJ1cmwoI2IpIj4KICAgICAgICAgICAgPHBhdGggZD0iTTIwIDBIMHYyMGgyMHoiLz4KICAgICAgICA8L2c+CiAgICA8L2c+Cjwvc3ZnPgo=');
    background-repeat: no-repeat;
    background-position: 15px 15px;

    & > .title {
      font-weight: 500;
      margin-bottom: 15px;
    }

    & > .buttons {
      display: flex;
      flex-wrap: wrap;
      margin-top: 20px;
      @media #{$mobile} {
        justify-content: center;
      }
      & .message-button {
        background-color: transparent;
        color: $titleColor;
        cursor: pointer;
        font-size: 15px;
        font-weight: normal;
        letter-spacing: normal;
        transition-duration: .3s;
        padding: 10px 15px;
        margin: 0px 15px 0px 0px;
        // &:hover {
        //   background-color: rgba(255, 255, 255, 0.5);
        //   transition-duration: .3s;

        // }
        &.cardPay {
          border-radius: 5px;
          border: solid 1px #707070;
        }
        @media #{$mobile} {
          width: 100%;
          text-align: center;
          margin-top: 20px;
        }

        &:first-child {
          margin-left: 0;
        }

        &:last-child {
          margin-left:  0;
        }

        &:only-child {
          margin: 5px;
        }
      }
    }
  }
  .bonus_balance {
    color: #4d92e3 !important;
  }
  .red {
    margin: -10px 0 5px;
  }

  .radio-button {
    padding: 14px 40px 28px;
    border-bottom: 1px solid #e9eff4;
  }

  .img-card-radio-button {
    height: 24px;
    position: relative;
    left: 47px;
    top: -2px
  }

  .select-block-for-add-card {
    width: 100%;
    background: #ffffff;
    padding: 20px 40px;
  }

  .card-radio-button {
    position: relative;
    left: 55px;
    font-family: Roboto;
    font-size: 15px;
    font-weight: 500;
    font-style: normal;
    font-stretch: normal;
    top: -7px;
    line-height: 1.33;
    letter-spacing: normal;
    color: #323c47;
  }

  .container-radio {
    display: block;
    position: relative;
    padding-left: 38px;
    cursor: pointer;
    font-size: 22px;
    -webkit-user-select: none;
    -moz-user-select: none;
    -ms-user-select: none;
    user-select: none;
  }

  /* Hide the browser's default radio button */
  .container-radio input {
    position: absolute;
    opacity: 0;
    cursor: pointer;
  }

  /* Create a custom radio button */
  .checkmark-radio {
    position: absolute;
    top: 0;
    left: 0;
    height: 20px;
    width: 20px;
    background-color: #f8f8f8;
    border-radius: 50%;
    border: solid 1px #e9eff4;
  }

  /* On mouse-over, add a grey background color */
  .container-radio:hover input ~ .checkmark-radio {
    background-color: #ccc;
  }

  /* When the radio button is checked, add a blue background */
  .container-radio input:checked ~ .checkmark-radio {
    background-color: #e4f3e0;
  }

  /* Create the indicator (the dot/circle - hidden when not checked) */
  .checkmark-radio:after {
    content: "";
    position: absolute;
    display: none;
  }

  /* Show the indicator (dot/circle) when checked */
  .container-radio input:checked ~ .checkmark-radio:after {
    display: block;
  }

  /* Style the indicator (dot/circle) */
  .container-radio .checkmark-radio:after {
    top: 6px;
    left: 6px;
    width: 6px;
    height: 6px;
    border-radius: 50%;
    background: #51a351;
  }

  .select-img-card {
    position: absolute;
    top: 53px;
    height: 25px;
    right: 20px;
  }
  .pay-result-warning{
    border: 1px solid #ffd012;
    -webkit-border-radius: 6px;
    -moz-border-radius: 6px;
    border-radius: 6px;
    padding: 20px 10px 0;
  }

  .ui-alert-body {
    @media #{$mobile} {

    }

    .ui-button {
      background-color: transparent !important;
      font-weight: normal;
      font-style: normal;
      font-stretch: normal;
      line-height: 1.33;
      letter-spacing: normal;
      color: #323c47 !important;

      &.primary {
        border: 1px solid #707070;
      }
    }
  }
</style>
